/*
 * scanMenu.cpp: Channelscan/-tune plugin for the Video Disk Recorder
 *
 * Menuimplementation
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */
#include "scanMenu.h"
#include "scanThread.h"
#include "tune.h"
#include "i18n.h"
#include <vdr/interface.h>
#include <iostream.h>

cScanMenu::cScanMenu(cPluginTune* Parent)
:cOsdMenu("")
{
 parent = Parent;
 Bar = NULL;
 //Bar1 = new cProgressBar(200,580);
 //delete Bar1;
 //Comp = Bar1;
 Set();
 //Display();
 //Comp->Draw();
}//cScanMenu::cScanMenu(cScanThread* Thread)

cScanMenu::~cScanMenu()
{
 cout << "Destructor cScanMenu ... ";
 parent->DelMenu();
 delete Bar;
 cout << "done." << endl;
}//cScanMenu::~cScanMenu()

eOSState cScanMenu::ProcessKey(eKeys Key)
{
  eOSState state = cOsdMenu::ProcessKey(Key);

if (state == osUnknown) {
     switch (Key) {
       case kRed:{
        if(!parent->hasThread()) {
	   parent->GetNewThread();
	  if(!parent->StartThread()) {
	    Interface->Error(tr("Error: Can't start scan-thread!"));
	    parent->DelThread();
	   }//if
         }//if
        else {
	  parent->DelThread();
	  }//else
        return StartCancel();
	}//case
       case kMenu: return osEnd;
       default: break;
       }
     }/**/
  return state;
}//eOSState cScanMenu::ProcessKey(eKeys Key)

void cScanMenu::Set(void)
{
  Clear();
  SetTitle(tr("Tune"));
  StartCancel();
  Bar = new cProgressBar(200,580);
  Display();
}//void cScanMenu::Set(void)

eOSState cScanMenu::StartCancel()
{
 if(!parent->hasThread()||!parent->runThread()) {
  SetHelp(tr("Start"));
  }//if
 else {
   SetHelp(tr("Cancel"));
  }//else/**/
 return osContinue;
}//eOSState cScanMenu::Cancel()

void cScanMenu::SetTitle(const char *title, bool t)
{
 cOsdMenu::SetTitle(title,t);
}//void cScanMenu::SetTitle(const char *title, bool t)

void cScanMenu::Display()
{
 cout << "Menu::Display" << endl;
 Bar->Draw();
}//void cScanMenu::Display()

void cScanMenu::Bar1Current(int Curr)
{
 Bar->setCurrent(Curr);
 Bar->Draw();
}//void cScanMenu::Bar1Current(int Curr)

void cScanMenu::Bar1Total(int Total)
{
 Bar->setTotal(Total);
 Bar->Draw();
}//void cScanMenu::Bar1Total(int Total)
