/*
 * scanMenu.h: Channelscan/-tune plugin for the Video Disk Recorder
 *
 * Menuimplementation
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */

#ifndef __SCANMENU_H
#define __SCANMENU_H

#include <vdr/osd.h>
#include <vdr-components/progressbar.h>

class cScanThread;
class cPluginTune;

class cScanMenu : public cOsdMenu {
private:
  cPluginTune*  parent;    // needed for access the scanThread
  cProgressBar* Bar;
  cComponent* Comp;
  eOSState StartCancel();
public:
  cScanMenu(cPluginTune* Parent);
  virtual ~cScanMenu();
  virtual eOSState ProcessKey(eKeys Key);
  void Display();
  virtual void Set(void);
  void SetTitle(const char *, bool = 1);
  void Bar1Current(int Curr);
  void Bar1Total(int Total);
};

#endif // __SCANMENU_H
