/*
 * scanThread.cpp: Channelscan/-tune plugin for the Video Disk Recorder
 *
 * Thread
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */

#include "scanThread.h"
#include <vdr/interface.h>
#include "i18n.h"

#include <unistd.h>
#include <iostream.h>

cScanThread::cScanThread()
{
 dvb = NULL;
 menu = NULL;
 Channels = new cChannels;
 running = false;
 muted   = false;
 //test = new cProgressBar(40,10,10,30);
}//cScanThread::cScanThread(cDvbApi* dvb)

cScanThread::~cScanThread()
{
 running = false;
 Stop();
 while(Active())  // warten, bis Thread wirklich beendet wurde. besonders wichtig, wenn VDR (Vers. 1.1.1) beendet wird,
  Cancel();       // da ansonsten ein Speicherzugriffsfehler auftritt. vieleicht ein Bug in VDR?!?

 delete Channels;
 menu = NULL;
 dvb=NULL;
}//cScanThread::~cScanThread()

void cScanThread::Action()
{
 int i = 0;
 if(menu)
  menu->Bar1Total(200);
 if(cDvbApi::PrimaryDvbApi==dvb && !dvb->IsMute())
   muted=cDvbApi::PrimaryDvbApi->ToggleMute();

 while(running) {
   i++;
   sleep(1); //only for testing thread-behavior
   if(menu) {
     menu->Bar1Current(i);
     menu->SetTitle(tr("Tune"));
     cout << "Menu->Display" << endl;
     menu->Display();
     //menu->Bar1Current(i);
    }//if
  }//for
 //running = false;

 if(muted&&cDvbApi::PrimaryDvbApi->IsMute())
   muted=cDvbApi::PrimaryDvbApi->ToggleMute();
}//cScanThread::Action()

bool cScanThread::Start()
{
 cDvbApi* tmp=cDvbApi::GetDvbApi(0,10);
 SetDevice(tmp);
 running = true;
 return cThread::Start();
}//bool cScanThread::Start()

void cScanThread::Stop()
{
 running = false;
 Cancel();
}//void cScanThread::Stop()

/*
void cScanThread::PauseResume()
{
 pause = (pause)?false:true;
}//void cScanThread::Pause()
*/

void cScanThread::SetMenu(cScanMenu* Menu)
{
 menu = Menu;
 //Interface->Info("Menu gesetzt.");
}//void cScanThread::SetMenu(cScanMenu* Menu)

void cScanThread::DelMenu()
{
 menu = NULL;
 //Interface->Info("Menu gelscht.");
}//void cScanThread::DelMenu()

bool cScanThread::isRunning()
{
 return running;
}//bool cScanThread::isRunning()

/*bool cScanThread::isPaused()
{
 return pause;
}//bool cScanThread::isPaused()
*/
void cScanThread::SetDevice(cDvbApi* Dvb)
{
 char buffer  [72];
 char buffer2 [32];
 char buffer3 [32];

 dvb = Dvb;
 if(cDvbApi::PrimaryDvbApi==dvb)
  snprintf(buffer2,sizeof(buffer2),tr("Primary DVB interface"));
 else
  snprintf(buffer2,sizeof(buffer2),tr("DVB-Card %i"),dvb->CardIndex());

 if(running) {
   if(cDvbApi::PrimaryDvbApi==dvb)
    snprintf(buffer3,sizeof(buffer3),tr("Primary DVB interface"));
   else
    snprintf(buffer3,sizeof(buffer3),tr("DVB-Card %i"),Dvb->CardIndex());
   snprintf(buffer, sizeof(buffer),tr("Change %s to %s."),buffer2,buffer3);
  }//if
 else snprintf(buffer, sizeof(buffer),tr("Use %s for scanning channels."),buffer2);

  Interface->Info(buffer);

}//void cScanThread::SetDevice(cDvbApi* Dvb)
