/*
 * scanThread.h: Channelscan/-tune plugin for the Video Disk Recorder
 *
 * Thread
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */

#ifndef __SCANTHREAD_H
#define __SCANTHREAD_H

#include <vdr/thread.h>
#include <vdr/dvbapi.h>
#include <vdr/config.h>
#include "scanMenu.h"

class cScanThread : public cThread
{
 private:
  cDvbApi* dvb;
  cChannels* Channels;
  cScanMenu* menu;
  bool running;
  bool muted;
 protected:
  virtual void Action(void);
 public:
  cScanThread();
  virtual ~cScanThread();
  void SetMenu(cScanMenu* Menu);
  void SetDevice(cDvbApi* Dvb);
  void DelMenu();
  bool Start();
  void Stop();
  //void PauseResume();
  bool isRunning();
  //bool isPaused();
};//class cScanThread

#endif
