/*
 * tune.h: Channelscan/-tune plugin for the Video Disk Recorder
 *
 * Plugin-Core
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */
 
#ifndef __TUNE_PLUGIN_H
#define __TUNE_PLUGIN_H

#include <vdr/plugin.h>

class cScanThread;
class cScanMenu;

class cPluginTune : public cPlugin {
private:
  // Add any member variables or functions you may need here.
  cScanThread *thread;
  cScanMenu   *menu;
public:
  cPluginTune(void);
  virtual ~cPluginTune();
  virtual const char *Version(void);
  virtual const char *Description(void);
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Start(void);
  virtual const char *MainMenuEntry(void);
  virtual cOsdMenu *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);


  void GetNewThread();
  void DelThread();
  void DelMenu();
  bool hasThread();
  bool StartThread();
  bool runThread();
};

#endif //__TUNE_PLUGIN_H
