/*
 * object.h: Componentlibrary for the Video Disk Recorder
 *
 * Library-Core
 *
 * (C) 2002 Mirko Gnther <mi.guenther@ib-helms.de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 *
 */

#ifndef VDRC__OBJECTS_H
#define VDRC__OBJECTS_H

#include <vdr/tools.h>
//#include <vdr/interface.h>


class cObject                                                    // Interfaceclass
{
 private:
  char* PluginName;
 protected:
 public:
  cObject();
  virtual ~cObject();
  virtual char* ClassID(void) = 0;
    const char* getPluginName();
          void  setPluginName(char* plName);

};//class cObject

class cComponent : public cObject //, public cListObject          // Baseclass for Components
{
 private:
  char* name;
 protected:
   virtual void Paint(void) = 0 ;
 public:
  cComponent(char* Name);
  virtual ~cComponent();
  virtual void Draw() = 0;
  virtual char* ClassID(void) {return "cComponent";}
};//class cComponent
/*
template<class T> class cComponentList : public cList<T>
{
};//template<class T> class cComponentList : public cList<T>

class cComponents : public cComponentList<cComponent>
{
};//class cComponents : public cComponents<cComponent>
*/
#endif VDRC__OBJECTS_H
